
#include <windows.h>
#include <malloc.h>

BOOL ShutdownWindows( UINT nMode );

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, 
					LPSTR lpCmdLine, int nCmdShow )
{
	UINT nMode = 0;
	int nResut = 0;
	BOOL bShutdown  = FALSE;
	BOOL bForce = FALSE;
	int i;
	BOOL bOption = FALSE;

	for ( i = 0; lpCmdLine[i] != '\0'; i++ ) {
		if ( lpCmdLine[i] == '-' ) {
			bOption = TRUE;
		}
		if ( lpCmdLine[i] == '/' ) {
			bOption = TRUE;
		}
		if ( lpCmdLine[i] == ' ' ) {
			bOption = FALSE;
		}
		else if ( bOption ) {
			switch( tolower( lpCmdLine[i] ) ) {
			case 'f':
				bForce = TRUE;
				break;
			case 'l':
				bShutdown = TRUE;
				nMode = EWX_LOGOFF;
				break;
			case 'p':
				bShutdown = TRUE;
				nMode = EWX_POWEROFF;
				break;
			case 'r':
				bShutdown = TRUE;
				nMode = EWX_REBOOT;
				break;
			case 's':
				bShutdown = TRUE;
				nMode = EWX_SHUTDOWN;
				break;
			}
		}
	}
	if ( bForce ) {
		nMode |= EWX_FORCE;
	}
	if ( bShutdown ) {
		if ( !ShutdownWindows( nMode ) ) {
			nResut = -1;
		}
	}
	else {
		MessageBox(NULL, 
				"shutdown -[lrsp] [-f]\nOption:\n  f:Force\n  l:Logoff  r:Reboot\n  s:Shutdown  p:Poweroff",
				"shutdown help",
				MB_OK);
	}
	return nResut;
}

BOOL ShutdownWindows( UINT nMode )
{
	BOOL bResult = TRUE;
	HANDLE hToken = NULL;
	TOKEN_PRIVILEGES Tp;
	BOOL bRebootAfterShutdown;
	ZeroMemory( &Tp, sizeof(Tp) );
	
	if ( nMode & EWX_REBOOT || nMode & EWX_SHUTDOWN || nMode & EWX_POWEROFF ) {
		OSVERSIONINFO osver;
		ZeroMemory( &osver, sizeof(osver) );
		osver.dwOSVersionInfoSize = sizeof(osver);
		GetVersionEx(&osver);
		if ( osver.dwPlatformId == VER_PLATFORM_WIN32_NT )  {
			// g[NJ
			bResult = OpenProcessToken( GetCurrentProcess(),
										TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY,
										&hToken );
			if ( !bResult ) {
				return FALSE;
			}
			// ݂
			Tp.PrivilegeCount = 1;
			bResult = LookupPrivilegeValue( "",
											SE_SHUTDOWN_NAME,
											&Tp.Privileges[0].Luid );

			if ( !bResult ) {
				return FALSE;
			}
			// ύX
			Tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
			bResult = AdjustTokenPrivileges( hToken, FALSE, &Tp, 0, NULL, NULL);
			if ( !bResult || GetLastError() != ERROR_SUCCESS ) {
				return FALSE;
			}
		}
	}
#if 0
	bRebootAfterShutdown = FALSE;
	if ( nMode & EWX_REBOOT ) {
		bRebootAfterShutdown = TRUE;
	}
	if (nMode & EWX_REBOOT || nMode & EWX_SHUTDOWN || nMode & EWX_POWEROFF) {
		InitiateSystemShutdown( NULL, "Vbg_E܂",
								20, FALSE,
								bRebootAfterShutdown );
	}
	else {
#endif
		ExitWindowsEx( nMode, 0 );
#if 0
	}
#endif
	if ( hToken != NULL ) {
		// ύXɖ߂
		Tp.Privileges[0].Attributes = 0;
		bResult = AdjustTokenPrivileges( hToken, FALSE, &Tp, 0, NULL, NULL);
		CloseHandle( hToken );
	}
	return TRUE;
}

